org.bdgenomics.adam.rdd.read

# ReadDataset

###
Related Docs: object ReadDataset | package read

#### sealed abstract class ReadDataset extends AvroGenomicDataset[Read, Read, ReadDataset]

Linear Supertypes
AvroGenomicDataset[Read, Read, ReadDataset], GenomicDataset[Read, Read, ReadDataset], Logging, AnyRef, Any
Known Subclasses
DatasetBoundReadDataset, ParquetUnboundReadDataset, RDDBoundReadDataset
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ReadDataset
2. AvroGenomicDataset
3. GenomicDataset
4. Logging
5. AnyRef
6. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract val dataset: Dataset[Read]

   These data as a Spark SQL Dataset.

   These data as a Spark SQL Dataset.

   Definition Classes
     GenomicDataset

2. #### abstract val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]

   Attributes
     protected
   Definition Classes
     GenomicDataset

3. #### abstract val rdd: RDD[Read]

   The RDD of genomic data that we are wrapping.

   The RDD of genomic data that we are wrapping.

   Definition Classes
     GenomicDataset

4. #### abstract def replaceSequences(newSequences: SequenceDictionary): ReadDataset

   Replaces the sequence dictionary attached to a GenomicDataset.

   Replaces the sequence dictionary attached to a GenomicDataset.

   newSequences

     The new sequence dictionary to attach.

   returns

     Returns a new GenomicDataset with the sequences replaced.

   Definition Classes
     GenomicDataset

5. #### abstract val sequences: SequenceDictionary

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   Definition Classes
     GenomicDataset

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def addSequence(sequenceToAdd: SequenceRecord): ReadDataset

   Appends metadata for a single sequence to the current genomic dataset.

   Appends metadata for a single sequence to the current genomic dataset.

   sequenceToAdd

     The sequence to add.

   returns

     Returns a new GenomicDataset with this sequence appended.

   Definition Classes
     GenomicDataset

5. #### def addSequences(sequencesToAdd: SequenceDictionary): ReadDataset

   Appends sequence metadata to the current genomic dataset.

   Appends sequence metadata to the current genomic dataset.

   sequencesToAdd

     The new sequences to append.

   returns

     Returns a new GenomicDataset with the sequences appended.

   Definition Classes
     GenomicDataset

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def broadcast()(implicit tTag: ClassTag[Read]): GenomicBroadcast[Read, Read, ReadDataset]

   Definition Classes
     GenomicDataset

8. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], txTag: ClassTag[(Read, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Y)]): GenericGenomicDataset[(Read, X), (Read, Y)]

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

   genomicDataset

     The right genomic dataset in the join.

   returns

     Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicDataset
   See also

     broadcastRegionJoinAgainst

9. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], txTag: ClassTag[(Read, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Y)]): GenericGenomicDataset[(Read, X), (Read, Y)]

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   Performs a broadcast inner join between this genomic dataset and another genomic dataset.

   In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

   genomicDataset

     The right genomic dataset in the join.

   flankSize

     Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

   returns

     Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicDataset
   See also

     broadcastRegionJoinAgainst

10. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Read, X), (Read, Y)]

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

11. #### def broadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Read, X), (Read, Y)]

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset

12. #### def broadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Y, Read)]): GenericGenomicDataset[(X, Read), (Y, Read)]

    Performs a broadcast inner join between this genomic dataset and data that has been broadcast.

    Performs a broadcast inner join between this genomic dataset and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

13. #### def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], Read)]): GenericGenomicDataset[(Iterable[X], Read), (Seq[Y], Read)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

14. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Read], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Read], Y)]): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

15. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Read], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Read], Y)]): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

16. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

17. #### def broadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast inner join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    See also

      broadcastRegionJoinAgainstAndGroupByRight

18. #### def buildTree(rdd: RDD[(ReferenceRegion, Read)])(implicit tTag: ClassTag[Read]): IntervalArray[ReferenceRegion, Read]

    Attributes
      protected
    Definition Classes
      ReadDataset → GenomicDataset

19. #### def cache(): ReadDataset

    Caches underlying RDD in memory.

    Caches underlying RDD in memory.

    returns

      Cached GenomicDataset.

    Definition Classes
      GenomicDataset

20. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

21. #### def debug(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

22. #### def debug(msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

23. #### def debug(msg: ⇒ Any): Unit

    Attributes
      protected
    Definition Classes
      Logging

24. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

25. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

26. #### def error(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

27. #### def error(msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

28. #### def error(msg: ⇒ Any): Unit

    Attributes
      protected
    Definition Classes
      Logging

29. #### def filterByOverlappingRegion(query: ReferenceRegion): ReadDataset

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the query region.

    Definition Classes
      GenomicDataset

30. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): ReadDataset

    (Java-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    (Java-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

31. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): ReadDataset

    (Scala-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    (Scala-specific) Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicDataset containing only data that overlaps the querys region.

    Definition Classes
      GenomicDataset

32. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

33. #### def flattenRddByRegions(): RDD[(ReferenceRegion, Read)]

    Attributes
      protected
    Definition Classes
      GenomicDataset

34. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otoxTag: ClassTag[(Option[Read], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Option[Y])]): GenericGenomicDataset[(Option[Read], Option[X]), (Option[Read], Option[Y])]

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

35. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otoxTag: ClassTag[(Option[Read], Option[X])], ouoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Option[Y])]): GenericGenomicDataset[(Option[Read], Option[X]), (Option[Read], Option[Y])]

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

36. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Read], Option[X]), (Option[Read], Option[Y])]

    (Python-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    (Python-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

37. #### def fullOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Read], Option[X]), (Option[Read], Option[Y])]

    (R-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge full outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either genomic dataset does not overlap any values in the other genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicDataset

38. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

39. #### def getReferenceRegions(read: Read): Seq[ReferenceRegion]

    read

      Read to extract a region from.

    returns

      Returns a reference region that covers the entirety of the read.

    Attributes
      protected
    Definition Classes
      ReadDataset → GenomicDataset

40. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

41. #### def info(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

42. #### def info(msg: ⇒ Any, t: ⇒ Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

43. #### def info(msg: ⇒ Any): Unit

    Attributes
      protected
    Definition Classes
      Logging

44. #### def isDebugEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

45. #### def isErrorEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

46. #### def isInfoEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

47. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

48. #### def isSorted: Boolean

    Definition Classes
      GenomicDataset

49. #### def isTraceEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

50. #### def isWarnEnabled: Boolean

    Attributes
      protected
    Definition Classes
      Logging

51. #### lazy val jrdd: JavaRDD[Read]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicDataset

52. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], toxTag: ClassTag[(Read, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Option[Y])]): GenericGenomicDataset[(Read, Option[X]), (Read, Option[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

53. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], toxTag: ClassTag[(Read, Option[X])], uoyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Option[Y])]): GenericGenomicDataset[(Read, Option[X]), (Read, Option[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

54. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Read, Option[X]), (Read, Option[Y])]

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

55. #### def leftOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Read, Option[X]), (Read, Option[Y])]

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

56. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], toxTag: ClassTag[(Read, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Seq[Y])]): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

57. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], toxTag: ClassTag[(Read, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Seq[Y])]): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

58. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (Java-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

59. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    (R-specific) Performs a sort-merge left outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right genomic dataset that do not overlap a value from the left genomic dataset are dropped. If a value from the left genomic dataset does not overlap any values in the right genomic dataset, it will be paired with an empty Iterable in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left genomic dataset that did not overlap a key in the right genomic dataset.

    Definition Classes
      GenomicDataset

60. #### def logger: Logger

    Attributes
      protected
    Definition Classes
      Logging

61. #### def loggerName: String

    Attributes
      protected
    Definition Classes
      Logging

62. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

63. #### final def notify(): Unit

    Definition Classes
      AnyRef

64. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

65. #### def persist(sl: StorageLevel): ReadDataset

    Persists underlying RDD in memory or disk.

    Persists underlying RDD in memory or disk.

    sl

      new StorageLevel

    returns

      Persisted GenomicDataset.

    Definition Classes
      GenomicDataset

66. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[Read, Read, ReadDataset, W]](cmd: List[String], files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[ReadDataset, RDD[X], Z]): Z

    (Java/Python-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (Java/Python-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final genomic dataset.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

67. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[Read, Read, ReadDataset, W]](cmd: Seq[Any], files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[W], xFormatter: OutFormatter[X], convFn: Function2[ReadDataset, RDD[X], Z]): Z

    (R-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (R-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final genomic dataset.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

68. #### def pipe[X, Y <: Product, Z <: GenomicDataset[X, Y, Z], W <: InFormatter[Read, Read, ReadDataset, W]](cmd: Seq[String], files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0, optTimeout: Option[Int] = None)(implicit tFormatterCompanion: InFormatterCompanion[Read, Read, ReadDataset, W], xFormatter: OutFormatter[X], convFn: (ReadDataset, RDD[X]) ⇒ Z, tManifest: ClassTag[Read], xManifest: ClassTag[X]): Z

    (Scala-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    (Scala-specific) Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicDataset. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicDataset containing X's.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    optTimeout

      An optional parameter specifying how long to let a single partition run for, in seconds. If the partition times out, the partial results will be returned, and no exception will be logged. The partition will log that the command timed out.

    returns

      Returns a new GenomicDataset of type Y.

    Definition Classes
      GenomicDataset

69. #### val productFn: (Read) ⇒ Read

    Attributes
      protected
    Definition Classes
      ReadDataset → GenomicDataset

70. #### def replaceRdd(newRdd: RDD[Read], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): ReadDataset

    newRdd

      The RDD to replace the underlying RDD with.

    newPartitionMap

      New partition map, if any.

    returns

      Returns a new ReadDataset with the underlying RDD replaced.

    Attributes
      protected
    Definition Classes
      ReadDataset → GenomicDataset

71. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otxTag: ClassTag[(Option[Read], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Y)]): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

72. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otxTag: ClassTag[(Option[Read], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Y)]): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoin

73. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset

74. #### def rightOuterBroadcastRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left genomic dataset (this genomic dataset) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset

75. #### def rightOuterBroadcastRegionJoinAgainst[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], oyuTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Y], Read)]): GenericGenomicDataset[(Option[X], Read), (Option[Y], Read)]

    Performs a broadcast right outer join between this genomic dataset and data that has been broadcast.

    Performs a broadcast right outer join between this genomic dataset and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoin

76. #### def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](broadcast: GenomicBroadcast[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], syuTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Y], Read)]): GenericGenomicDataset[(Iterable[X], Read), (Seq[Y], Read)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcast

      The data on the left side of the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicDataset
    Note

      This function differs from other region joins as it treats the calling genomic dataset as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoinAndGroupByRight

77. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Read], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Read], Y)]): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

78. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[Read], X)], iuyTag: scala.reflect.api.JavaUniverse.TypeTag[(Seq[Read], Y)]): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

79. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

80. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Iterable[Read], X), (Seq[Read], Y)]

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a broadcast right outer join between this genomic dataset and another genomic dataset.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

81. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otxTag: ClassTag[(Option[Read], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Y)]): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset

82. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otxTag: ClassTag[(Option[Read], X)], ouyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Y)]): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset

83. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset

84. #### def rightOuterShuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Read], X), (Option[Read], Y)]

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left genomic dataset that do not overlap a value from the right genomic dataset are dropped. If a value from the right genomic dataset does not overlap any values in the left genomic dataset, it will be paired with a `None` in the product of the join.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right genomic dataset that did not overlap a key in the left genomic dataset.

    Definition Classes
      GenomicDataset

85. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otixTag: ClassTag[(Option[Read], Iterable[X])], otsyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Seq[Y])]): GenericGenomicDataset[(Option[Read], Iterable[X]), (Option[Read], Seq[Y])]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset

86. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], otixTag: ClassTag[(Option[Read], Iterable[X])], ousyTag: scala.reflect.api.JavaUniverse.TypeTag[(Option[Read], Seq[Y])]): GenericGenomicDataset[(Option[Read], Iterable[X]), (Option[Read], Seq[Y])]

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset

87. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Option[Read], Iterable[X]), (Option[Read], Seq[Y])]

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    (Java-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset

88. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Option[Read], Iterable[X]), (Option[Read], Seq[Y])]

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    (R-specific) Performs a sort-merge right outer join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset. Since this is a right outer join, all values from the right genomic dataset who did not overlap a value from the left genomic dataset are placed into a length-1 Iterable with a `None` key.

    genomicDataset

      The right genomic dataset in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset, and all values from the right genomic dataset that did not overlap an item in the left genomic dataset.

    Definition Classes
      GenomicDataset

89. #### def save(filePath: String, asSingleFile: Boolean): Unit

    Save reads as Parquet or FASTQ.

    Save reads as Parquet or FASTQ.

    If filename ends in .fq or .fastq, saves as FASTQ. If not, saves reads to Parquet.

    filePath

      Path to save files to.

    asSingleFile

      If true, saves output as a single file.

90. #### def saveAsFastq(filePath: String, asSingleFile: Boolean = false, disableFastConcat: Boolean = false): Unit

    Save reads in FASTQ format.

    Save reads in FASTQ format.

    filePath

      Path to save files to.

    asSingleFile

      If true, saves output as a single file.

    disableFastConcat

      If asSingleFile is true, disables the use of the parallel file merging engine.

91. #### def saveAsParquet(pathName: String): Unit

    Saves this genomic dataset to disk as a Parquet file.

    Saves this genomic dataset to disk as a Parquet file.

    pathName

      Path to save the file at.

    Definition Classes
      AvroGenomicDataset

92. #### def saveAsParquet(pathName: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

    (Java-specific) Saves this genomic dataset to disk as a Parquet file.

    (Java-specific) Saves this genomic dataset to disk as a Parquet file.

    pathName

      Path to save the file at.

    blockSize

      The size in bytes of blocks to write.

    pageSize

      The size in bytes of pages to write.

    compressCodec

      The compression codec to apply to pages.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used.

    Definition Classes
      AvroGenomicDataset

93. #### def saveAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

    Saves this genomic dataset to disk as a Parquet file.

    Saves this genomic dataset to disk as a Parquet file.

    pathName

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing. Default is false.

    Definition Classes
      AvroGenomicDataset → GenomicDataset

94. #### def saveAsParquet(args: SaveArgs): Unit

    Saves a genomic dataset to Parquet.

    Saves a genomic dataset to Parquet.

    args

      The output format configuration to use when saving the data.

    Definition Classes
      GenomicDataset

95. #### def saveAsPartitionedParquet(pathName: String, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, partitionSize: Int = 1000000): Unit

    Saves this RDD to disk in range binned partitioned Parquet format.

    Saves this RDD to disk in range binned partitioned Parquet format.

    pathName

      The path to save the partitioned Parquet file to.

    compressCodec

      Name of the compression codec to use.

    partitionSize

      Size of partitions used when writing Parquet, in base pairs (bp). Defaults to 1,000,000 bp.

    Definition Classes
      GenomicDataset

96. #### def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

    Saves Avro data to a Hadoop file system.

    Saves Avro data to a Hadoop file system.

    This method uses a SparkContext to identify our underlying file system, which we then save to.

    Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

    U

      The type of the specific record we are saving.

    pathName

      Path to save records to.

    sc

      SparkContext used for identifying underlying file system.

    schema

      Schema of records we are saving.

    avro

      Seq of records we are saving.

    Attributes
      protected
    Definition Classes
      GenomicDataset

97. #### def saveMetadata(pathName: String): Unit

    Called in saveAsParquet after saving genomic dataset to Parquet to save metadata.

    Called in saveAsParquet after saving genomic dataset to Parquet to save metadata.

    Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

    pathName

      The filepath to the file where we will save the Metadata.

    Attributes
      protected
    Definition Classes
      AvroGenomicDataset → GenomicDataset

98. #### def savePartitionMap(pathName: String): Unit

    Save the partition map to disk.

    Save the partition map to disk. This is done by adding the partition map to the schema.

    pathName

      The filepath where we will save the partition map.

    Attributes
      protected
    Definition Classes
      AvroGenomicDataset

99. #### def saveRddAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, optSchema: Option[Schema] = None): Unit

    Saves a genomic dataset of Avro data to Parquet.

    Saves a genomic dataset of Avro data to Parquet.

    pathName

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write. Defaults to 128 * 1024 * 1024.

    pageSize

      The size in bytes of pages to write. Defaults to 1 * 1024 * 1024.

    compressCodec

      The compression codec to apply to pages. Defaults to CompressionCodecName.GZIP.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used. Defaults to false.

    optSchema

      The optional schema to set. Defaults to None.

    Attributes
      protected
    Definition Classes
      AvroGenomicDataset

100. #### def saveRddAsParquet(args: SaveArgs): Unit

     Attributes
       protected
     Definition Classes
       AvroGenomicDataset

101. #### def saveSequences(pathName: String): Unit

     Save the sequence dictionary to disk.

     Save the sequence dictionary to disk.

     pathName

       The path to save the sequence dictionary to.

     Attributes
       protected
     Definition Classes
       GenomicDataset

102. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], txTag: ClassTag[(Read, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Y)]): GenericGenomicDataset[(Read, X), (Read, Y)]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

103. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], txTag: ClassTag[(Read, X)], uyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Y)]): GenericGenomicDataset[(Read, X), (Read, Y)]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

104. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Read, X), (Read, Y)]

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

105. #### def shuffleRegionJoin[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Read, X), (Read, Y)]

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space.

     Definition Classes
       GenomicDataset

106. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z])(implicit tTag: ClassTag[Read], xTag: ClassTag[X], tixTag: ClassTag[(Read, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Seq[Y])]): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

107. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Long)(implicit tTag: ClassTag[Read], xTag: ClassTag[X], tixTag: ClassTag[(Read, Iterable[X])], uiyTag: scala.reflect.api.JavaUniverse.TypeTag[(Read, Seq[Y])]): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other genomic dataset are dropped. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

108. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Integer): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     (Java-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

109. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](genomicDataset: GenomicDataset[X, Y, Z], flankSize: Double): GenericGenomicDataset[(Read, Iterable[X]), (Read, Seq[Y])]

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     (R-specific) Performs a sort-merge inner join between this genomic dataset and another genomic dataset, followed by a groupBy on the left value.

     In a sort-merge join, both genomic datasets are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the genomic dataset.

     genomicDataset

       The right genomic dataset in the join.

     flankSize

       Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

     returns

       Returns a new genomic dataset containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left genomic dataset.

     Definition Classes
       GenomicDataset

110. #### def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[Read]): ReadDataset

     Sorts our genome aligned data by reference positions, with references ordered by index.

     Sorts our genome aligned data by reference positions, with references ordered by index.

     partitions

       The number of partitions for the new genomic dataset.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

     See also

       sortLexicographically

111. #### def sort(): ReadDataset

     Sorts our genome aligned data by reference positions, with references ordered by index.

     Sorts our genome aligned data by reference positions, with references ordered by index.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sortLexicographically

112. #### def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[Read]): ReadDataset

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     partitions

       The number of partitions for the new genomic dataset.

     storePartitionMap

       A Boolean flag to determine whether to store the partition bounds from the resulting genomic dataset.

     storageLevel

       The level at which to persist the resulting genomic dataset.

     stringency

       The level of ValidationStringency to enforce.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     Note

       Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

     See also

       sort

113. #### def sortLexicographically(): ReadDataset

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     Sorts our genome aligned data by reference positions, with references ordered lexicographically.

     returns

       Returns a new genomic dataset containing sorted data.

     Definition Classes
       GenomicDataset
     See also

       sort

114. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

115. #### def toAlignments: AlignmentRecordDataset

     Convert this genomic dataset of reads into alignments.

     Convert this genomic dataset of reads into alignments.

     returns

       Returns a new AlignmentRecordDataset converted from this genomic dataset of alignments.

116. #### def toDF(): DataFrame

     returns

       These data as a Spark SQL DataFrame.

     Definition Classes
       GenomicDataset

117. #### def toSequences: SequenceDataset

     Convert this genomic dataset of reads into sequences.

     Convert this genomic dataset of reads into sequences.

     returns

       Returns a new SequenceDataset converted from this genomic dataset of reads.

118. #### def toSlices: SliceDataset

     Convert this genomic dataset of reads into slices.

     Convert this genomic dataset of reads into slices.

     returns

       Returns a new SliceDataset converted from this genomic dataset of reads.

119. #### def toString(): String

     Definition Classes
       GenomicDataset → AnyRef → Any

120. #### def trace(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

121. #### def trace(msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

122. #### def trace(msg: ⇒ Any): Unit

     Attributes
       protected
     Definition Classes
       Logging

123. #### def transform(tFn: Function[JavaRDD[Read], JavaRDD[Read]]): ReadDataset

     (Java-specific) Applies a function that transforms the underlying RDD into a new RDD.

     (Java-specific) Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

124. #### def transform(tFn: (RDD[Read]) ⇒ RDD[Read]): ReadDataset

     (Scala-specific) Applies a function that transforms the underlying RDD into a new RDD.

     (Scala-specific) Applies a function that transforms the underlying RDD into a new RDD.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

125. #### def transformDataFrame(tFn: Function[DataFrame, DataFrame]): ReadDataset

     (Java-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     (Java-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying DataFrame as a DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

126. #### def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[Read]): ReadDataset

     (Scala-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     (Scala-specific) Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

     tFn

       A function that transforms the underlying data as a DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

127. #### def transformDataset(tFn: Function[Dataset[Read], Dataset[Read]]): ReadDataset

     (Java-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     (Java-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     tFn

       A function that transforms the underlying Dataset as a Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       ReadDataset → GenomicDataset

128. #### def transformDataset(tFn: (Dataset[Read]) ⇒ Dataset[Read]): ReadDataset

     (Scala-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     (Scala-specific) Applies a function that transforms the underlying Dataset into a new Dataset using the Spark SQL API.

     tFn

       A function that transforms the underlying Dataset as a Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       ReadDataset → GenomicDataset

129. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[JavaRDD[Read], JavaRDD[X]], convFn: Function2[ReadDataset, RDD[X], Z]): Z

     (Java-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     (Java-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new genomid dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

130. #### def transmute[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (RDD[Read]) ⇒ RDD[X])(implicit convFn: (ReadDataset, RDD[X]) ⇒ Z): Z

     (Scala-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     (Scala-specific) Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new genomic dataset where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

131. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[Read, Read, ReadDataset, X, Y, Z]): Z

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     tFn

       A function that transforms the underlying DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

132. #### def transmuteDataFrame[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (DataFrame) ⇒ DataFrame)(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (ReadDataset, Dataset[Y]) ⇒ Z): Z

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     (Java-specific) Applies a function that transmutes the underlying DataFrame into a new DataFrame of a different type.

     tFn

       A function that transforms the underlying DataFrame.

     returns

       A new genomic dataset where the DataFrame of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

133. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: Function[Dataset[Read], Dataset[Y]], convFn: GenomicDatasetConversion[Read, Read, ReadDataset, X, Y, Z]): Z

     (Java-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     (Java-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     tFn

       A function that transforms the underlying Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

134. #### def transmuteDataset[X, Y <: Product, Z <: GenomicDataset[X, Y, Z]](tFn: (Dataset[Read]) ⇒ Dataset[Y])(implicit yTag: scala.reflect.api.JavaUniverse.TypeTag[Y], convFn: (ReadDataset, Dataset[Y]) ⇒ Z): Z

     (Scala-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     (Scala-specific) Applies a function that transmutes the underlying Dataset into a new Dataset of a different type.

     tFn

       A function that transforms the underlying Dataset.

     returns

       A new genomic dataset where the Dataset of genomic data has been replaced, but the metadata (sequence dictionary, and etc) are copied without modification.

     Definition Classes
       GenomicDataset

135. #### val uTag: scala.reflect.api.JavaUniverse.TypeTag[Read]

     Definition Classes
       ReadDataset → GenomicDataset

136. #### def union(datasets: ReadDataset*): ReadDataset

     (Scala-specific) Unions together multiple genomic datasets.

     (Scala-specific) Unions together multiple genomic datasets.

     datasets

       Genomic datasets to union with this genomic dataset.

     Definition Classes
       ReadDataset → GenomicDataset

137. #### def union(datasets: List[ReadDataset]): ReadDataset

     (Java-specific) Unions together multiple genomic datasets.

     (Java-specific) Unions together multiple genomic datasets.

     datasets

       Genomic datasets to union with this genomic dataset.

     Definition Classes
       GenomicDataset

138. #### def unpersist(): ReadDataset

     Unpersists underlying RDD from memory or disk.

     Unpersists underlying RDD from memory or disk.

     returns

       Uncached GenomicDataset.

     Definition Classes
       GenomicDataset

139. #### val unproductFn: (Read) ⇒ Read

     Attributes
       protected
     Definition Classes
       ReadDataset → GenomicDataset

140. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

141. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

142. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

143. #### def warn(mkr: Marker, msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

144. #### def warn(msg: ⇒ Any, t: ⇒ Throwable): Unit

     Attributes
       protected
     Definition Classes
       Logging

145. #### def warn(msg: ⇒ Any): Unit

     Attributes
       protected
     Definition Classes
       Logging

146. #### def writePartitionedParquetFlag(pathName: String, partitionSize: Int): Unit

     Save partition size into the partitioned Parquet flag file.

     Save partition size into the partitioned Parquet flag file.

     pathName

       Path to save the file at.

     partitionSize

       Partition bin size, in base pairs, used in Hive-style partitioning.

     Definition Classes
       AvroGenomicDataset → GenomicDataset

147. #### def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicDataset

### Inherited from AvroGenomicDataset[Read, Read, ReadDataset]

### Inherited from GenomicDataset[Read, Read, ReadDataset]

### Inherited from Logging

### Inherited from AnyRef

### Inherited from Any

### Ungrouped